When submitting a solution in C++, please select either C++14 (GCC 6-32) or C++17 (GCC 7-32) as your compiler. ×

BledDest's blog

By BledDest, history, 4 years ago, In English
Div2A
Div2B/Div1A
Div2C
Div2D/Div1B
Div2E/Div1C
Div2F/Div1D
Div1E
Div1F
  • Vote: I like it
  • +54
  • Vote: I do not like it

| Write comment?
»
4 years ago, # |
  Vote: I like it -32 Vote: I do not like it

Nice editorial :)

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

so unlucky with problem div.2 E ;( thanks for editorials. can someone check my code and find my bug? i was debuging for 2 hours and found nothing. my code

  • »
    »
    4 years ago, # ^ |
      Vote: I like it +2 Vote: I do not like it

    The test on which your code is failing is small in size(n=m=p=10) so you can use it as a counter-testcase and debug..

»
4 years ago, # |
  Vote: I like it -9 Vote: I do not like it

I have a problem with 1321C - Remove Adjacent. I don't really understand how the answer to the first test case is $$$4$$$

According to the problem, $$$ 1 \leq i \leq |s| $$$
Let s = $$$bacabcab$$$

$$$1$$$) We remove $$$s_2$$$ = $$$a$$$ and we get $$$s$$$ = $$$bcabcab$$$
$$$2$$$) We remove $$$s_2$$$ = $$$c$$$ and we get $$$s$$$ = $$$babcab$$$
$$$3$$$) We remove $$$s_1$$$ = $$$b$$$ and we get $$$s$$$ = $$$abcab$$$
$$$4$$$) We remove $$$s_3$$$ = $$$c$$$ and we get $$$s$$$ = $$$abab$$$
$$$5$$$) We remove $$$s_3$$$ = $$$a$$$ and we get $$$s$$$ = $$$abb$$$
$$$6$$$) We remove $$$s_2$$$ = $$$b$$$ and we get $$$s$$$ = $$$ab$$$
$$$7$$$) We remove $$$s_2$$$ = $$$b$$$ and we get $$$s$$$ = $$$a$$$

Which cannot be shortened further. So we removed a total of $$$7$$$ characters. Shouldn't that be the optimal answer?

  • »
    »
    4 years ago, # ^ |
      Vote: I like it +5 Vote: I do not like it

    'a' can never be removed as it has no previous letter (see problem statement)

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I think you misunderstood the meaning of this problem. You should read it again carefully.

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    We can't remove 'a'.it's mentioned in the problem.

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Actually i got very confused so according to question b is previous element of a, or y is previous element of z,but a is not previous element of d.I wasted a lot of time in this

»
4 years ago, # |
Rev. 6   Vote: I like it +4 Vote: I do not like it

I'm confused by the editorial for Div2F/Div1D. When I tried to implement it I seem to always get WA buried somewhere in test case 6, and I don't really know how it handles the case of odd number of consecutive ones, or the case:

$$$11010 \rightarrow 01110 \rightarrow 01011$$$

Edit: Oh, I think you meant deleting the $$$1$$$ s from the string altogether. I turned out to be converting them into $$$0$$$ s instead, which is clearly wrong

Edit 2: And now I fail at test 10. This is tough.

Edit 3: Got it. Had to add special handling for "empty" strings.

»
4 years ago, # |
  Vote: I like it +6 Vote: I do not like it

I don't understand this explanation for Div2C.

Why is it always true? Suppose we remove the maximum letter i that can be used to remove some other letter j (it is obvious that si+1=sj in such case). If there are no other letters between si and sj then si is not the maximum letter, so we got contradiction with our algorithm. Now suppose that we can remove all letters between si and sj. Then we first choose sj and only after that si by our algorithm. Consider the last case — there is at least one letter sk between si and sj. Because we cannot remove sk then there are only two cases: sk>sj+1 or sk+1<si. Then we cannot use si to remove sj at all.

Can somebody explain it please?

  • »
    »
    4 years ago, # ^ |
      Vote: I like it +7 Vote: I do not like it

    For me that just proofs that for the lexicographically last letter (ie 'z') there is no letter after that one. Then it states that if such one is removed, all other possible removals still exist. So we can remove letters in reverse lexicographically order. Kind of induction.

»
4 years ago, # |
  Vote: I like it +8 Vote: I do not like it

Please, add author solutions too.

»
4 years ago, # |
  Vote: I like it +10 Vote: I do not like it

Hey, is there anyone here knows other problems that need to use the tree compression trick like D1E? I learned it before but I forgot :(

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone explain div1D please? I just can't get the point of what the tutorial is saying...

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    In short, the tuition is like this. Since you have the transformation is to change "011" to "110" and vice versa, the parity of the number of "1" between any two consecutive "0"s remains. Therefore, if there is any "11" in our original string, the fact that you delete it would not change anything. Just delete all "11" in the original string, and you obtain a shorter new string. To answer queries, just pick the substrings of the new string that correspond to the substrings in the original, and compare if they are the same.

    • »
      »
      »
      4 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Thanks a lot bro! A lot nicer explanation!

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In div2E as per my understanding we need to implement segment tree to support max query over cumulative sum. Am I right?

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    For those like me — This problem requires segment tree with lazy update

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In problem div2 D how is the minimum rebuild in example 3 0? why is not 1?

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    If you make the transposed graph (basically all edges in opposite direction) and calculate the shortest distance from the last node, you'll see that the given path is indeed the shortest path from 8 to 1. Therefore, if I take this path on node 8, I can continue with this. Question asked rebuilds not builds so first build is excluded.

»
4 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

Can anyone help me find which test case my code for DIV2-B fails.

  • »
    »
    4 years ago, # ^ |
    Rev. 2   Vote: I like it 0 Vote: I do not like it

    You have an error in overflowing values. The maximum value for n is 2*10^5, for each number 4*10^5. Multiplying these numbers we get 8*10^10. While int can store data up to 2*10^9. Replace the int with long long. P.S. And in general, I would recommend doing this task the way it is editorial, because on big tests you will get TL.

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

I couldn't understand the editorial of Div2C .It will be great if someone explain it to me. Moreover,I cannot figure out which case i am missing.here is my code:https://codeforces.com/contest/1321/submission/72240578

  • »
    »
    4 years ago, # ^ |
    Rev. 2   Vote: I like it 0 Vote: I do not like it

    It is something as follow: We first try to remove occurrences of 'z'. Now if there any 'z' remaining that can't be removed. Then we remove occurrences of 'y' wherever possible. and so on.

    And here in each pass you can scan entire array. As there are only about 100 characters.

    Now, you may ask why we are not starting with 'a' then 'b' then 'c' and so on...?

    Because suppose you have following string — 'cbca'. Then if we had tried to remove 'b' then it would not be remove after it's pass gets over. But after removing 'c' string becomes 'ba'. So, we find out that we can also remove 'b'.

    And if you think a little bit than you will see that in our approach of removing characters in reverse alphabetical order once we find that we can't remove given character then we will never be able to remove that character in future.

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Div2C also has a $$$O(n^3)$$$ dp solution https://codeforces.com/contest/1321/submission/74736147

  • »
    »
    3 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    can you explain it's states?

    • »
      »
      »
      3 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      $$$dp[i][j][c]$$$ is whether we can use some sequence of moves to reduce the substring $$$s[i..j]$$$ to the character $$$c$$$ or not. After that $$$dp2[i]$$$ is the minumum length we can obtain on the prefix after some sequence of moves

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Is it necessary to use lazy propagation in div1 C? Thanks

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Apologies, for div2D, this is failing on test 7 and I can't figure out what's up, could anyone look through and maybe see the logic? My # of possible cases is more than that of the test's.

https://codeforces.com/contest/1320/submission/76050423

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can't figure out what's wrong:

https://codeforces.com/contest/1321/submission/77013730

Basically, I compute shortest paths in the transposed graph in a table dist. dist[X] is the shortest path length from node X to node P[K].

Then, looping I = 2 to K (i.e 2nd to last node):

I check if p[I - 1] to p[I] is an edge in some shortest path from P[I - 1] to the last node (i.e. P[K]. I check this by checking dist[P[I]] == dist[P[I - 1]] - 1.

  • If the check fails, then both max and min increase by 1, because in both cases, we need to rebuild because we transitioned to a non shortest-path edge.

  • If the check succeeds, then I check if how many outgoing edges does P[I - 1] have that's part of some shortest path:

    • if there's more than one, then I increment max only because the worst case is when the navigation system suggested a different path.
    • if there's only one, then max and min doesn't change.

Maybe my bfs is wrong

  • »
    »
    4 years ago, # ^ |
    Rev. 2   Vote: I like it 0 Vote: I do not like it

    Lol yep, my bfs is wrong.

    In my implementation, it's possible that's nodes can be pushed twice in the queue. This should not be the case when counting paths. I got AC after fixing this.

»
4 years ago, # |
  Vote: I like it +6 Vote: I do not like it

Codeforces Round 625 div2 D wa4。 I can not make sense. https://codeforces.com/contest/1321/submission/82265166

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can anyone please explain me the editorial of div2E/div1C?

  • »
    »
    4 years ago, # ^ |
    Rev. 2   Vote: I like it +12 Vote: I do not like it

    Let's represent all the monsters as the points at the coordinate plane: a monster with $$$x$$$ toughness, $$$y$$$ power, and $$$z$$$ coins is represented by the point $$$(x,y)$$$ with value $$$z$$$. For each pair of a sword with power $$$x_0$$$ and a shield with toughness $$$y_0$$$, the result is the sum of values over the points which belong to the rectangle $$$0 \leqslant x < x_0, 0 \leqslant y < y_0$$$ minus their costs.
    Let's now apply the scanline technique: we will process the events of two types: a new monster and a new sword. Let's build a segment tree over the (sorted by toughness) list of shields and define the current set of monsters (initially empty) as $$$S$$$. For each shield with toughness $$$y_0$$$ and cost $$$c$$$, a leaf value in the segment tree stores

    $$$-c+\sum\limits_{\substack{m \in S \\ y(m) < y_0}} z(m)$$$

    Let's sort an array of events by $$$x$$$. If some sword has the same power as some monster's toughness, then the sword is processed before. For each event in the sorted order:
    - If it's a monster with power $$$y$$$ and value $$$z$$$, then for each shield with the higher toughness add $$$z$$$, which means adding on some suffix segment of the segment tree. That monster is added to $$$S$$$;
    - If it's a sword with power $$$y$$$, then you need to find the shield with the biggest value in the segment tree. The final answer is the biggest value among the values of these pairs.

»
4 years ago, # |
Rev. 3   Vote: I like it 0 Vote: I do not like it

can anyone tell me why i am getting TLE in div1-A. Here's my submission 87744808

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

DP solution for journey planning is giving TLE. O(n^2) isn't fast enough even for 2 second time limit?

»
3 years ago, # |
  Vote: I like it 0 Vote: I do not like it

1320D — Reachable Strings can be solved in O(n) with hashes without a segment tree. I have put Submission for reference.

»
7 months ago, # |
  Vote: I like it 0 Vote: I do not like it

can anyone please explain for problem A how ceil[(y+1)/x] can be answer.x can be any integer right adding 1 to y will necessarily not increase the answer by 1 right . BledDest

»
5 months ago, # |
  Vote: I like it +3 Vote: I do not like it

can anyone help me how to dij in div1E ??